<?php
/*
    [123imagestock] (C)2006-2007 123imagestock Software. All Rights Reserved.
    This is NOT a freeware, use is subject to license terms
*/
function file_extension($filename)
    {
    $path_info=pathinfo($filename);
    return $path_info['extension'];
    }

function format_file_size($size = 0)
    {
    $kb=1024;       // Kilobyte
    $mb=1024 * $kb; // Megabyte
    $gb=1024 * $mb; // Gigabyte
    $tb=1024 * $gb; // Terabyte

    if ($size < $kb)
        {
        return $size . " B";
        }
    else if ($size < $mb)
        {
        return round($size / $kb, 2) . " KB";
        }
    else if ($size < $gb)
        {
        return round($size / $mb, 2) . " MB";
        }
    else if ($size < $tb)
        {
        return round($size / $gb, 2) . " GB";
        }
    else
        {
        return round($size / $tb, 2) . " TB";
        }
    }

function get_user_os()
    {
    if (!empty($HTTP_SERVER_VARS['HTTP_USER_AGENT']))
        {
        $HTTP_USER_AGENT=$HTTP_SERVER_VARS['HTTP_USER_AGENT'];
        }
    elseif (getenv("HTTP_USER_AGENT"))
        {
        $HTTP_USER_AGENT=getenv("HTTP_USER_AGENT");
        }
    elseif (empty($HTTP_USER_AGENT))
        {
        $HTTP_USER_AGENT="";
        }

    if (eregi("Win", $HTTP_USER_AGENT))
        {
        $os="WIN";
        }
    elseif (eregi("Mac", $HTTP_USER_AGENT))
        {
        $os="MAC";
        }
    else
        {
        $os="OTHER";
        }

    return $os;
    }

function timeTrans($time)
    {
    if (ereg("^([0-9]{4})-([0-9]{1,2})-([0-9]{1,2})[ ]{1,}([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})$", $time))
        {
        ereg("^([0-9]{4})-([0-9]{1,2})-([0-9]{1,2})[ ]{1,}([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})$", $time, $regs);
        $time=mktime($regs[4], $regs[5], $regs[6], $regs[2], $regs[3], $regs[1]);
        }
    else if (ereg("^([0-9]{4})-([0-9]{1,2})-([0-9]{1,2})$", $time))
        {
        ereg("^([0-9]{4})-([0-9]{1,2})-([0-9]{1,2})", $time, $regs);
        $time=mktime(0, 0, 0, $regs[2], $regs[3], $regs[1]);
        }

    return $time;
    }

function checkIdName($val)
    {
    global $lang;

    if (strtolower($lang['encoding']) == 'utf-8')
        {
        if (preg_match('/^[a-zA-Z\d_]+$/', $val))
            {
            return true;
            }
        return false;
        }
    else
        {
            return true;
        }
    }

function checkTime($val)
    {
    if (ereg("^([0-9]{4})-([0-9]{1,2})-([0-9]{1,2})[ ]{1,}([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})$",
             $val) or ereg("^([0-9]{4})-([0-9]{1,2})-([0-9]{1,2})$", $val))
        {
        return true;
        }

    return false;
    }

function checkAddress($val)
    {
    if (preg_match('/^[-!#$%&\'*+\\.\/0-9=?A-Z^_`{|}~]+@([-0-9A-Z]+\.)+([0-9A-Z]){2,4}$/i', $val))
        {
        return true;
        }

    return false;
    }

function checkDomain($val)
    {
    if (preg_match("/^https?:\/\//i", $val))
        {
        return true;
        }

    return false;
    }

function checkIP($val)
    {
    $return=true;
    $tmp   =explode(".", $val);

    if (count($tmp) < 4)
        {
        $return=false;
        }
    else
        {
        foreach ($tmp as $sub)
            {
            if (!ereg("^([0-9])+$", $sub))
                {
                $return=false;
                }
            }
        }

    return $return;
    }

function checkBlank($val)
    {
    if (trim($val) == "")
        {
        return true;
        }

    return false;
    }

function checkInt($val)
    {
    if (strval(intval($val)) == $val)
        {
        return true;
        }

    return false;
    }

function checkFloat($val)
    {
    if (strval(floatval($val)) == $val)
        {
        return true;
        }

    return false;
    }

function create_navigation($pagecount, $currentpage)
    {
    global $lang;
    $navigation='';

    if ($pagecount > 0)
        {
        if ($currentpage == 1)
            {
            $navigation.='<span class="disable">&#171; ' . $lang['prev'] . '&nbsp;</span>';
            }
        else
            {
            $navigation.='<a href="#" class="link" onclick="setCurrentPage(' . ($currentpage - 1) . ');">&#171; '
                . $lang['prev'] . '&nbsp;</a>';
            }

        if ($currentpage - 4 > 0)
            {
            $navigation.='...';
            }

        for ($i=$currentpage - 4; $i < $currentpage; $i++)
            {
            if ($i > 0)
                {
                $navigation.='<a href="#" class="link" onclick="setCurrentPage(' . $i . ');">' . $i . '</a>';
                }
            }

        $navigation.='<span class="link" style="text-decoration: none !important">[' . $currentpage . ']</span>';

        for ($i=$currentpage + 1; $i <= $currentpage + 4; $i++)
            {
            if ($i <= $pagecount)
                {
                $navigation.='<a href="#" class="link" onclick="setCurrentPage(' . $i . ');">' . $i . '</a>';
                }
            }

        if ($currentpage + 4 < $pagecount)
            {
            $navigation.='...';
            }

        if ($currentpage == $pagecount)
            {
            $navigation.='<span class="disable">&nbsp;' . $lang['next'] . ' &#187;</span>';
            }
        else
            {
            $navigation.='<a href="#" class="link" onclick="setCurrentPage(' . ($currentpage + 1) . ');">&nbsp;'
                . $lang['next'] . ' &#187;</a>';
            }
        }

    return $navigation;
    }

//$imageId full path
function imageFullPath($imageId)
    {
    $dir=$GLOBALS['imageService']->imageFullPath($imageId);
    return $dir;
    }

function listUsers($searchuser, $allUser)
    {
    $user_list='';

    if ($allUser == 1)
        {
        $user_list.="<option style=\"background-color: white\" value=\"all\"";

        if ('all' == $searchuser)
            {
            $user_list.=" selected=\"selected\" ";
            }

        $user_list.=">Search All Users</option>\n";
        }

    $users=$GLOBALS['userService']->listUsers();

    foreach ($users as $index => $user)
        {
        $user_list.="<option value=\"" . $user['user_id'] . "\"";

        if ($user['user_id'] == $searchuser)
            {
            $user_list.=" selected=\"selected\" ";
            }

        $user_list.=">" . $user['user_name'] . "</option>\n";
        }

    return $user_list;
    }

function listRoles($searchrole, $allRole)
    {
    $role_list='';

    if ($allRole == 1)
        {
        $role_list.="<option style=\"background-color: white\" value=\"all\"";

        if ('all' == $searchrole)
            {
            $role_list.=" selected=\"selected\" ";
            }

        $role_list.=">Search All Roles</option>\n";
        }

    $roles=$GLOBALS['roleService']->listRoles();

    foreach ($roles as $index => $role)
        {
        $role_list.="<option value=\"" . $role['role_id'] . "\"";

        if ($role['role_id'] == $searchrole)
            {
            $role_list.=" selected=\"selected\" ";
            }

        $role_list.=">" . $role['role_name'] . "</option>\n";
        }

    return $role_list;
    }

function listCategories($cat_id, $depth, $searchcat, $allCat)
    {
    $category_list='';

    if ($depth == 0)
        {
        if ($allCat == 1)
            {
            $category_list.="<option style=\"background-color: white\" value=\"all\"";

            if ('all' == $searchcat)
                {
                $category_list.=" selected=\"selected\" ";
                }

            $category_list.=">Search All Categories</option>\n";
            }

        $category_list.="<option style=\"background-color: white\" value=\"1\"";

        if ('1' == $searchcat)
            {
            $category_list.=" selected=\"selected\" ";
            }

        $category_list.=">Root Categories</option>\n";
        }

    $categories=$GLOBALS['categoryService']->listCategories($cat_id);

    foreach ($categories as $index => $category)
        {
        $category_list.="<option style=\"BACKGROUND-COLOR: white\" value=\"" . $category['cat_id'] . "\"";

        if ($category['cat_id'] == $searchcat)
            {
            $category_list.=" selected=\"selected\" ";
            }

        $category_list.=">" . str_repeat("--", $depth) . $category['cat_name'] . "</option>\n";
        $category_list.=listCategories($category['cat_id'], $depth + 1, $searchcat, $flag);
        }

    return $category_list;
    }

function listCategoryRows($cat_id, $depth)
    {
    global $lang;
    $category_list='';

    $categories   =$GLOBALS['categoryService']->listCategories($cat_id);

    foreach ($categories as $index => $category)
        {
        $category_list.='<TR>';
        $category_list.='<TD class=left-column width="75%">' . str_repeat("&nbsp;&nbsp;&nbsp;&nbsp;", $depth) . ($depth == 0 ? '' : '<IMG alt="" 
            src="../css/folder_path.gif">') . '<IMG alt="" src="../css/folder.gif"><B>' . $category['cat_name'] . '</B><nobr>(ID: ' . $category['cat_id'] . ')</nobr>&nbsp;&nbsp;&nbsp;&nbsp;<nobr><A 
            href="admin.php?action=admin_edit_category&id=' . $category['cat_id'] . '">[' . $lang['edit'] . ']</A>&nbsp;&nbsp;<A 
            href="admin.php?action=admin_delete_category&id=' . $category['cat_id'] . '">[' . $lang['delete'] . ']</A>&nbsp;&nbsp;<A 
            href="admin.php?action=admin_add_category&pcategory=' . $category['cat_id'] . '">[' . $lang['addsub']
            . ']</A></nobr></TD>';

        $category_list.='<TD width="25%" align=middle><A 
            href="admin.php?action=admin_order_category&move=up&id=' . $category['cat_id'] . '"><IMG 
            src="../css/up_arrow.png" width=10 height=10 border=0></A> <A 
            href="admin.php?action=admin_order_category&move=down&id=' . $category['cat_id'] . '"><IMG 
            src="../css/down_arrow.png" width=10 height=10 border=0></A></TD>';
        $category_list.='</TR>';

        $category_list.=listCategoryRows($category['cat_id'], $depth + 1);
        }

    return $category_list;
    }

function listOrder($cat_id)
    {
    $order_list='';
    $order_list.='<option value="beginning">Beginning</option>';
    $order_list.='<option value="end">End</option>';
    $categories=$GLOBALS['categoryService']->listCategories($cat_id);

    foreach ($categories as $index => $category)
        {
        $order_list.='<option value="' . $category['cat_id'] . '">After ' . $category['cat_name'] . '</option>';
        }

    return $order_list;
    }

function listEmails($searchemail)
    {
    $email_list='';
    $roles     =$GLOBALS['roleService']->listRoles();

    foreach ($roles as $index => $role)
        {
        $email_list.='<OPTION value="0">__________________________</OPTION>';
        $email_list.='<OPTION value="0">' . $role['role_name'] . '</OPTION>';
        $emails=$GLOBALS['userService']->listEmailsByRolename($role['role_name']);

        foreach ($emails as $index => $email)
            {
            $email_list.='<OPTION value="' . $email['user_email'] . '"';

            if ($email['user_email'] == $searchemail)
                {
                $email_list.=" selected=\"selected\" ";
                }

            $email_list.='>&raquo;' . $email['user_name'] . '(' . $email['user_email'] . ')</OPTION>';
            }
        }

    return $email_list;
    }

function listKeywords()
    {
    $keyword_list='';
    $keywords    =$GLOBALS['keywordService']->listKeywords();

    foreach ($keywords as $index => $keyword)
        {
        $keyword_list.='<OPTION value="' . $keyword['keyword_id'] . '"';
        $keyword_list.='>&raquo;' . $keyword['keyword_text'] . '(' . $keyword['num'] . ')</OPTION>';
        }

    return $keyword_list;
    }

function listTables($table_prefix)
    {
    $table_list='';
    $tables    =$GLOBALS['generalService']->listTables();

    foreach ($tables as $index => $table)
        {
        $table_list.='<OPTION value="' . $table[0] . '"';

        if ($table_prefix != "")
            {
            if (preg_match("/^" . $table_prefix . "/i", $table[0]))
                {
                $table_list.=" selected=\"selected\" ";
                }
            }
        else
            {
            $table_list.=" selected=\"selected\" ";
            }

        $table_list.='>' . $table[0] . '</OPTION>';
        }

    return $table_list;
    }

function isLogin() { return isset($_SESSION['userId']); }

function checkPermission($permission)
    {
    if (!isLogin())
        {
        return false;
        }

    $array=explode(",", $_SESSION['userPermissions']);
    return (in_array($permission, $array));
    }

function create_errinfo($col, $err)
    { return '<span style="font-size: 14px; color: ' . $col . '; font-weight: bold; padding-right: 5px;">*</span>'
    . $err . '<br>'; }
?>